#pragma semicolon 1
#include <sourcemod>
#pragma newdecls required


Handle TimerRestart;

public Plugin myinfo = 
{
	name = "Restarts Server.",
	author = "-",
	description = "",
	version = "1.0",
	url = "https://forums.alliedmods.net/showthread.php?t=327515"
};

public void OnPluginStart()
{
	LoadTranslations("restart_server.phrases");
	
	RegAdminCmd("sm_restart", sm_restart, ADMFLAG_GENERIC, "Restart server in 10 seconds or given time");
	RegAdminCmd("sm_rst",     sm_restart, ADMFLAG_GENERIC, "Restart server in 10 seconds or given time");
}

public Action sm_restart(int client, int args)
{

	if(client == 0)
	{
		ReplyToCommand(client, "[SM] Only players can use this command");
		return Plugin_Handled;
	}

	if(!IsClientInGame(client)) return Plugin_Handled;


	if(TimerRestart != null)
	{
		ReplyToCommand(client, "[SM] Restart Server is already in progress");
		return Plugin_Handled;
	}

	int seconds = 10;

	if(args > 0)
	{
		char buffer[3];
		GetCmdArg(1, buffer, sizeof(buffer));
		seconds = StringToInt(buffer);
		
		if(seconds < 0)
		{
			seconds = 10;
		}
		else if(seconds > 120)
		{
			seconds = 120;
		}
	}

	TimerRestart = CreateTimer(1.0, timer_start, seconds, TIMER_REPEAT);

	char buffer[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, buffer, sizeof(buffer), "logs/restart_server.log");
	LogToFileEx(buffer, "Admin %L rebooted the server (seconds %i)", client, seconds);

	ReplyToCommand(client, "%t", "admin_warning", client);

	return Plugin_Handled;
}


public Action timer_start(Handle timer, int seconds)
{
	static int countdown = -5;

	if(countdown == -5)
	{
		countdown = seconds;
	}
	else
	{
		countdown--;
	}

	if(countdown > 0)
	{
		PrintHintTextToAll("%t", "countdown_timer", countdown);
		return Plugin_Continue;
	}
	else if(countdown >= -2)
	{
		PrintHintTextToAll("%t", "warning_restart");
		return Plugin_Continue;
	}


	ServerCommand("exit");
	return Plugin_Stop;
}